<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/iron-ajax/iron-ajax.html">
<link rel="import" href="/ts/common-elements/page-js/page-js.html">
<link rel="import" href="/ts/ajaxell/html/elements/ag-toaster/throws-toast.html">

<!--
[Page.js](https://visionmedia.github.io/page.js/)

`page-handler` uses the page.js library to catch and handle page flow.
This allows AjaXell to be a single-page web app and is the reason the loading
of a new panel doesn't require reloading the whole page.

-->
<dom-module id="page-handler">
    <template>
        <iron-ajax id="ajax" method="POST" handle-as="text" on-response="handleResponse"></iron-ajax>
    </template>
    <script>
Polymer({is:"page-handler",behaviors:[throwsToast],handleResponse:function(e,request){function allDOMnodes(element){var tagName=element.tagName;tagName&&tagName.indexOf("-")>0&&(importDefinitions[tagName]?(document.getElementById("panelprogress").indeterminate=!0,Polymer.isInstance(element)?document.getElementById("panelprogress").indeterminate=!1:Polymer.Base.importHref([importDefinitions[tagName]],function(){document.getElementById("panelprogress").indeterminate=!1})):console.error("Element definition not found!",tagName));for(var childNodes=Polymer.dom(element).childNodes,i=0;i<childNodes.length;i++){var child=childNodes[i];allDOMnodes(child)}}document.getElementById("panelprogress").indeterminate=!1;var response=request.response;if(0==response.length)this._show404();else if(0!==response.indexOf("<!doctype")){var resultbox=Polymer.dom(document.getElementById("tsgui_content_"));resultbox.innerHTML=response,allDOMnodes(resultbox.node)}else console.warn("page-handler: request returned main page, app is out of sync",request),this.throwToast({type:"info",message:"server has refreshed the session id"}),document.getElementById("session").updateID(),page.replace(page.current)},attached:function(){""==window.location.hash&&(window.location.hash="#!/"),this.$.ajax.url=window.location.origin+window.location.pathname,page.base("/"+window.location.pathname.split("/")[1]+"/"),page.start({hashbang:!0}),page("/",this._handleHome.bind(this)),page("/:group/:command",this._handleCommand.bind(this)),page("*",this._show404),page()},_handleHome:function(context,next){this.$.ajax.body=["_eventType_=OnClick","_id_=tsgui_tree_Control Panels_Home","tsgui_tree_Control Panels_Home=Home"].join("&"),this.$.ajax.generateRequest(),document.getElementById("path").textContent=""},_handleCommand:function(context,next){context.params.group&&context.params.command&&(context.params.group=context.params.group.split("%20").join(" "),context.params.command=context.params.command.split("%20").join(" "),this.$.ajax.body=["_eventType_=OnClick","_id_=tsgui_tree_"+context.params.group+"_"+context.params.command,"tsgui_tree_"+context.params.group+"_"+context.params.command+"="+context.params.command].join("&"),this.$.ajax.generateRequest(),document.getElementById("path").textContent=" ⟩ "+context.params.group+" ⟩ "+context.params.command,document.getElementById("panelprogress").indeterminate=!0)},_show404:function(){var content=Polymer.dom(document.querySelector("#tsgui_content_"));content.innerHTML="","/"!=page.current?(content.appendChild(document.createElement("error-404")),document.getElementById("path").textContent=" ⟩ ☠️"):(document.getElementById("path").textContent="",console.log("This cell does not yet have a default page defined"))}});
</script>
</dom-module>
